'use strict';

const CamstreamerAPI = function ()
{

  /**
   * @param {number} channel_id
   * @return {Promise<number>}
   */
  let getMaxFps = async function(channel_id)
  {
    return new Promise(function (resolve, reject) {
      $.get("/local/" + CS_OS.acap_name + "/get_max_framerate.cgi", {video_source: channel_id})
        .done( function (response) {
          var max_fps = parseInt(response, 10);
          if (max_fps === 0 || isNaN(max_fps)) {
            reject('INVALID_MAX_FPS');
          } else {
            resolve(max_fps);
          }
        })
        .fail( function(jqXHR, textStatus, errorThrown) {
          reject(errorThrown || 'Network error');
        });
    });
  };

  return Object.freeze({
    getMaxFps,
  });

};