'use strict';

const DiagnosticsAPI = function ()
{
    
    let packetLoss = async function() {
      return new Promise(function(resolve, reject) {
          $.get('/local/' + CS_OS.acap_name + '/diagnostics.cgi?pingtest=1')
              .done( function (response) {
                  if (response.status !== 200) {
                      reject('Request error');
                  } else {
                      resolve(response);
                  }
              })
              .fail( function(jqXHR, textStatus, errorThrown) {
                  reject(errorThrown || 'Network error');
              });
      });
    }

    let speedTest = async function() {
      return new Promise(function(resolve, reject) {
          $.get('/local/' + CS_OS.acap_name + '/diagnostics.cgi?speedtest=1')
          .done( function (response) {
              if (response.status !== 200) {
                  reject('Request error');
              } else {
                  resolve(response);
              }
          })
          .fail( function(jqXHR, textStatus, errorThrown) {
              reject(errorThrown || 'Network error');
          });
      });
    }

    let checkVideoHostPort = async function(domain, port) {
        return new Promise(function (resolve, reject) {
            $.get('/local/' + CS_OS.acap_name + '/diagnostics.cgi?videoHostPort=' + domain + ':' + port)
                .done( function (response) {
                    if (response.status !== 200) {
                        reject('Request error');
                    } else {
                        resolve(response);
                    }
                })
                .fail( function(jqXHR, textStatus, errorThrown) {
                    reject(errorThrown || 'Network error');
                });
        });
    }

    /**
    * @return {Promise<number>}
    */
    let checkCamStreamerServer = async function()
    {
    return new Promise(function (resolve, reject) {
        $.get('/local/' + CS_OS.acap_name + '/diagnostics.cgi?checkserver=1')
        .done( function (response) {
          if (response.status !== 200) {
            reject('Request error');
          } else {
            resolve(response);
          }
        })
        .fail( function(jqXHR, textStatus, errorThrown) {
          reject(errorThrown || 'Network error');
        });
    });
    };

    return Object.freeze({
      packetLoss,
      speedTest,
      checkVideoHostPort,
      checkCamStreamerServer,
    });

};